diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-capabilities.h ns-3.34/src/wifi/model/vht/vht-capabilities.h
--- ns-3.33/src/wifi/model/vht/vht-capabilities.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-capabilities.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,270 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Ghada Badawy <gbadawy@gmail.com>
+ *          Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef VHT_CAPABILITIES_H
+#define VHT_CAPABILITIES_H
+
+#include "ns3/wifi-information-element.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ *
+ * The IEEE 802.11ac VHT Capabilities
+ */
+class VhtCapabilities : public WifiInformationElement
+{
+public:
+  VhtCapabilities ();
+
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const override;
+  uint8_t GetInformationFieldSize () const override;
+  void SerializeInformationField (Buffer::Iterator start) const override;
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length) override;
+  /* This information element is a bit special in that it is only
+     included if the STA is an VHT STA. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const override;
+  uint16_t GetSerializedSize () const override;
+
+  /**
+   * Set the VHT supported field.
+   *
+   * \param vhtSupported the VHT supported field
+   */
+  void SetVhtSupported (uint8_t vhtSupported);
+
+  /**
+   * Set the VHT Capabilities Info field in the VHT Capabilities information element.
+   *
+   * \param ctrl the VHT Capabilities Info field in the VHT Capabilities information element
+   */
+  void SetVhtCapabilitiesInfo (uint32_t ctrl);
+  /**
+   * Set the MCS and NSS field in the VHT Capabilities information element.
+   *
+   * \param ctrl the MCS and NSS field in the VHT Capabilities information element
+   */
+  void SetSupportedMcsAndNssSet (uint64_t ctrl);
+
+  /**
+   * Return the VHT Capabilities Info field in the VHT Capabilities information element.
+   *
+   * \return the VHT Capabilities Info field in the VHT Capabilities information element
+   */
+  uint32_t GetVhtCapabilitiesInfo () const;
+  /**
+   * Return the MCS and NSS field in the VHT Capabilities information element.
+   *
+   * \return the MCS and NSS field in the VHT Capabilities information element
+   */
+  uint64_t GetSupportedMcsAndNssSet () const;
+
+  //Capabilities Info fields
+  /**
+   * Set the maximum MPDU length.
+   *
+   * \param length the maximum MPDU length (3895, 7991 or 11454)
+   */
+  void SetMaxMpduLength (uint16_t length);
+  /**
+   * Set the supported channel width set.
+   *
+   * \param channelWidthSet the supported channel width set
+   */
+  void SetSupportedChannelWidthSet (uint8_t channelWidthSet);
+  /**
+   * Set the receive LDPC.
+   *
+   * \param rxLdpc the receive LDPC
+   */
+  void SetRxLdpc (uint8_t rxLdpc);
+  /**
+   * Set the short guard interval 80 MHz.
+   *
+   * \param shortGuardInterval the short guard interval 80 MHz
+   */
+  void SetShortGuardIntervalFor80Mhz (uint8_t shortGuardInterval);
+  /**
+   * Set the short guard interval 160 MHz.
+   *
+   * \param shortGuardInterval the short guard interval 160 MHz
+   */
+  void SetShortGuardIntervalFor160Mhz (uint8_t shortGuardInterval);
+  /**
+   * Set the receive STBC.
+   *
+   * \param rxStbc the receive STBC
+   */
+  void SetRxStbc (uint8_t rxStbc);
+  /**
+   * Set the transmit STBC.
+   *
+   * \param txStbc the receive STBC
+   */
+  void SetTxStbc (uint8_t txStbc);
+  /**
+   * Set the maximum AMPDU length.
+   *
+   * \param maxAmpduLength 2^(13 + x) - 1, x in the range 0 to 7
+   */
+  void SetMaxAmpduLength (uint32_t maxAmpduLength);
+
+  /**
+   * Get the maximum MPDU length.
+   *
+   * \return the maximum MPDU length in bytes
+   */
+  uint16_t GetMaxMpduLength (void) const;
+  /**
+   * Get the supported channel width set.
+   *
+   * \returns the supported channel width set
+   */
+  uint8_t GetSupportedChannelWidthSet () const;
+  /**
+   * Get the receive LDPC.
+   *
+   * \returns the receive LDPC
+   */
+  uint8_t GetRxLdpc () const;
+  /**
+   * Get the receive STBC.
+   *
+   * \returns the receive STBC
+   */
+  uint8_t GetRxStbc () const;
+  /**
+   * Get the transmit STBC.
+   *
+   * \returns the transmit STBC
+   */
+  uint8_t GetTxStbc () const;
+
+  /**
+   * \param mcs Max MCS value (between 7 and 9)
+   * \param nss Spatial stream for which the Max MCS value is being set
+   */
+  void SetRxMcsMap (uint8_t mcs, uint8_t nss);
+  /**
+   * \param mcs Max MCS value (between 7 and 9)
+   * \param nss Spatial stream for which the Max MCS value is being set
+   */
+  void SetTxMcsMap (uint8_t mcs, uint8_t nss);
+  /**
+   * Set the receive highest supported LGI data rate.
+   *
+   * \param supportedDatarate receive highest supported LGI data rate
+   */
+  void SetRxHighestSupportedLgiDataRate (uint16_t supportedDatarate);
+  /**
+   * Set the transmit highest supported LGI data rate.
+   *
+   * \param supportedDatarate transmit highest supported LGI data rate
+   */
+  void SetTxHighestSupportedLgiDataRate (uint16_t supportedDatarate);
+  /**
+   * Get the is MCS supported.
+   *
+   * \param mcs the MCS
+   * \param nss the NSS
+   * \returns the is MCS supported
+   */
+  bool IsSupportedMcs (uint8_t mcs, uint8_t nss) const;
+
+  /**
+   * Get the receive highest supported LGI data rate.
+   *
+   * \returns the receive highest supported LGI data rate.
+   */
+  uint16_t GetRxHighestSupportedLgiDataRate () const;
+
+  /**
+   * Returns true if transmit MCS is supported.
+   *
+   * \param mcs the MCS
+   * \returns whether transmit MCS is supported
+   */
+  bool IsSupportedTxMcs (uint8_t mcs) const;
+  /**
+   * Returns true if receive MCS is supported.
+   *
+   * \param mcs the MCS
+   * \returns whether receive MCS is supported
+   */
+  bool IsSupportedRxMcs (uint8_t mcs) const;
+
+  /**
+   * Return the maximum A-MPDU length.
+   *
+   * \return the maximum A-MPDU length in bytes
+   */
+  uint32_t GetMaxAmpduLength (void) const;
+
+
+private:
+  //Capabilities Info fields
+  uint8_t m_maxMpduLength;               ///< maximum MPDU length
+  uint8_t m_supportedChannelWidthSet;    ///< supported channel width set
+  uint8_t m_rxLdpc;                      ///< receive LDPC
+  uint8_t m_shortGuardIntervalFor80Mhz;  ///< short guard interval for 80 MHz
+  uint8_t m_shortGuardIntervalFor160Mhz; ///< short guard interval for 160 MHz
+  uint8_t m_txStbc;                      ///< transmit STBC
+  uint8_t m_rxStbc;                      ///< receive STBC
+  uint8_t m_suBeamformerCapable;         ///< SU beamformer capable
+  uint8_t m_suBeamformeeCapable;         ///< SU beamformee capable
+  uint8_t m_beamformeeStsCapable;        ///< beamformee STS capable
+  uint8_t m_numberOfSoundingDimensions;  ///< number of sounding dimensions
+  uint8_t m_muBeamformerCapable;         ///< MU beamformer capable
+  uint8_t m_muBeamformeeCapable;         ///< MU beamformee capable
+  uint8_t m_vhtTxopPs;                   ///< VHT TXOP PS
+  uint8_t m_htcVhtCapable;               ///< HTC VHT capable
+  uint8_t m_maxAmpduLengthExponent;      ///< maximum A-MPDU length exponent
+  uint8_t m_vhtLinkAdaptationCapable;    ///< VHT link adaptation capable
+  uint8_t m_rxAntennaPatternConsistency; ///< receive antenna pattern consistency
+  uint8_t m_txAntennaPatternConsistency; ///< transmit antenna pattern consistency
+
+  //MCS and NSS field information
+  std::vector<uint8_t> m_rxMcsMap;                        ///< receive MCS map
+  uint16_t m_rxHighestSupportedLongGuardIntervalDataRate; ///< receive highest supported long guard interval data rate
+  std::vector<uint8_t> m_txMcsMap;                        ///< transmit MCS map
+  uint16_t m_txHighestSupportedLongGuardIntervalDataRate; ///< transmit highest supported long guard interval data rate
+
+  /// This is used to decide if this element should be added to the frame or not
+  uint8_t m_vhtSupported;
+};
+
+/**
+ * output stream output operator
+ *
+ * \param os the output stream
+ * \param vhtCapabilities the VHT capabilities
+ *
+ * \returns output stream
+ */
+std::ostream &operator << (std::ostream &os, const VhtCapabilities &vhtCapabilities);
+
+} //namespace ns3
+
+#endif /* VHT_CAPABILITY_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-configuration.cc ns-3.34/src/wifi/model/vht/vht-configuration.cc
--- ns-3.33/src/wifi/model/vht/vht-configuration.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-configuration.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,51 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018  Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "ns3/log.h"
+#include "vht-configuration.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("VhtConfiguration");
+
+NS_OBJECT_ENSURE_REGISTERED (VhtConfiguration);
+
+VhtConfiguration::VhtConfiguration ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+VhtConfiguration::~VhtConfiguration ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TypeId
+VhtConfiguration::GetTypeId (void)
+{
+  static ns3::TypeId tid = ns3::TypeId ("ns3::VhtConfiguration")
+    .SetParent<Object> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<VhtConfiguration> ()
+    ;
+    return tid;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-configuration.h ns-3.34/src/wifi/model/vht/vht-configuration.h
--- ns-3.33/src/wifi/model/vht/vht-configuration.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-configuration.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,52 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018  Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef VHT_CONFIGURATION_H
+#define VHT_CONFIGURATION_H
+
+#include "ns3/object.h"
+
+namespace ns3 {
+
+/**
+ * \brief VHT configuration
+ * \ingroup wifi
+ *
+ * This object stores VHT configuration information, for use in modifying
+ * AP or STA behavior and for constructing VHT-related information elements.
+ *
+ */
+class VhtConfiguration : public Object
+{
+public:
+  VhtConfiguration ();
+  virtual ~VhtConfiguration ();
+
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+};
+
+} //namespace ns3
+
+#endif /* VHT_CONFIGURATION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-frame-exchange-manager.cc ns-3.34/src/wifi/model/vht/vht-frame-exchange-manager.cc
--- ns-3.33/src/wifi/model/vht/vht-frame-exchange-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-frame-exchange-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,61 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "ns3/abort.h"
+#include "vht-frame-exchange-manager.h"
+
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT std::clog << "[mac=" << m_self << "] "
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("VhtFrameExchangeManager");
+
+NS_OBJECT_ENSURE_REGISTERED (VhtFrameExchangeManager);
+
+TypeId
+VhtFrameExchangeManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::VhtFrameExchangeManager")
+    .SetParent<HtFrameExchangeManager> ()
+    .AddConstructor<VhtFrameExchangeManager> ()
+    .SetGroupName ("Wifi")
+  ;
+  return tid;
+}
+
+VhtFrameExchangeManager::VhtFrameExchangeManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+VhtFrameExchangeManager::~VhtFrameExchangeManager ()
+{
+  NS_LOG_FUNCTION_NOARGS ();
+}
+
+Ptr<WifiPsdu>
+VhtFrameExchangeManager::GetWifiPsdu (Ptr<WifiMacQueueItem> mpdu, const WifiTxVector& txVector) const
+{
+  return Create<WifiPsdu> (mpdu, txVector.GetModulationClass () >= WIFI_MOD_CLASS_VHT);
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-frame-exchange-manager.h ns-3.34/src/wifi/model/vht/vht-frame-exchange-manager.h
--- ns-3.33/src/wifi/model/vht/vht-frame-exchange-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-frame-exchange-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,51 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef VHT_FRAME_EXCHANGE_MANAGER_H
+#define VHT_FRAME_EXCHANGE_MANAGER_H
+
+#include "ns3/ht-frame-exchange-manager.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ *
+ * VhtFrameExchangeManager handles the frame exchange sequences
+ * for VHT stations.
+ */
+class VhtFrameExchangeManager : public HtFrameExchangeManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  VhtFrameExchangeManager ();
+  virtual ~VhtFrameExchangeManager ();
+
+protected:
+  Ptr<WifiPsdu> GetWifiPsdu (Ptr<WifiMacQueueItem> mpdu, const WifiTxVector& txVector) const override;
+};
+
+} //namespace ns3
+
+#endif /* VHT_FRAME_EXCHANGE_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-operation.cc ns-3.34/src/wifi/model/vht/vht-operation.cc
--- ns-3.33/src/wifi/model/vht/vht-operation.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-operation.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,174 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2016 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#include "vht-operation.h"
+
+namespace ns3 {
+
+VhtOperation::VhtOperation ()
+  : m_channelWidth (0),
+    m_channelCenterFrequencySegment0 (0),
+    m_channelCenterFrequencySegment1 (0),
+    m_basicVhtMcsAndNssSet (0),
+    m_vhtSupported (0)
+{
+}
+
+WifiInformationElementId
+VhtOperation::ElementId () const
+{
+  return IE_VHT_OPERATION;
+}
+
+void
+VhtOperation::SetVhtSupported (uint8_t vhtSupported)
+{
+  m_vhtSupported = vhtSupported;
+}
+
+uint8_t
+VhtOperation::GetInformationFieldSize () const
+{
+  //we should not be here if VHT is not supported
+  NS_ASSERT (m_vhtSupported > 0);
+  return 5;
+}
+
+void
+VhtOperation::SetChannelWidth (uint8_t channelWidth)
+{
+  m_channelWidth = channelWidth;
+}
+
+void
+VhtOperation::SetChannelCenterFrequencySegment0 (uint8_t channelCenterFrequencySegment0)
+{
+  m_channelCenterFrequencySegment0 = channelCenterFrequencySegment0;
+}
+
+void
+VhtOperation::SetChannelCenterFrequencySegment1 (uint8_t channelCenterFrequencySegment1)
+{
+  m_channelCenterFrequencySegment1 = channelCenterFrequencySegment1;
+}
+
+void
+VhtOperation::SetMaxVhtMcsPerNss (uint8_t nss, uint8_t maxVhtMcs)
+{
+  NS_ASSERT ((maxVhtMcs == 0 || (maxVhtMcs >= 7 && maxVhtMcs <= 9)) && (nss >= 1 && nss <= 8));
+  if (maxVhtMcs != 0)
+    {
+      m_basicVhtMcsAndNssSet |= (((maxVhtMcs - 7) & 0x03) << ((nss - 1) * 2));
+    }
+  else
+    {
+      m_basicVhtMcsAndNssSet |= (3 << ((nss - 1) * 2));
+    }
+}
+
+void
+VhtOperation::SetBasicVhtMcsAndNssSet (uint16_t basicVhtMcsAndNssSet)
+{
+  m_basicVhtMcsAndNssSet = basicVhtMcsAndNssSet;
+}
+
+uint8_t
+VhtOperation::GetChannelWidth (void) const
+{
+  return m_channelWidth;
+}
+
+uint8_t
+VhtOperation::GetChannelCenterFrequencySegment0 (void) const
+{
+  return m_channelCenterFrequencySegment0;
+}
+
+uint8_t
+VhtOperation::GetChannelCenterFrequencySegment1 (void) const
+{
+  return m_channelCenterFrequencySegment1;
+}
+
+uint16_t
+VhtOperation::GetBasicVhtMcsAndNssSet (void) const
+{
+  return m_basicVhtMcsAndNssSet;
+}
+
+Buffer::Iterator
+VhtOperation::Serialize (Buffer::Iterator i) const
+{
+  if (m_vhtSupported < 1)
+    {
+      return i;
+    }
+  return WifiInformationElement::Serialize (i);
+}
+
+uint16_t
+VhtOperation::GetSerializedSize () const
+{
+  if (m_vhtSupported < 1)
+    {
+      return 0;
+    }
+  return WifiInformationElement::GetSerializedSize ();
+}
+
+void
+VhtOperation::SerializeInformationField (Buffer::Iterator start) const
+{
+  if (m_vhtSupported == 1)
+    {
+      //write the corresponding value for each bit
+      start.WriteU8 (GetChannelWidth ());
+      start.WriteU8 (GetChannelCenterFrequencySegment0 ());
+      start.WriteU8 (GetChannelCenterFrequencySegment1 ());
+      start.WriteU16 (GetBasicVhtMcsAndNssSet ());
+    }
+}
+
+uint8_t
+VhtOperation::DeserializeInformationField (Buffer::Iterator start, uint8_t length)
+{
+  Buffer::Iterator i = start;
+  uint8_t channelWidth = i.ReadU8 ();
+  uint8_t channelCenterFrequencySegment0 = i.ReadU8 ();
+  uint8_t channelCenterFrequencySegment1 = i.ReadU8 ();
+  uint16_t basicVhtMcsAndNssSet = i.ReadU16 ();
+  SetChannelWidth (channelWidth);
+  SetChannelCenterFrequencySegment0 (channelCenterFrequencySegment0);
+  SetChannelCenterFrequencySegment1 (channelCenterFrequencySegment1);
+  SetBasicVhtMcsAndNssSet (basicVhtMcsAndNssSet);
+  return length;
+}
+
+std::ostream &
+operator << (std::ostream &os, const VhtOperation &VhtOperation)
+{
+  os << +VhtOperation.GetChannelWidth () << "|"
+     << +VhtOperation.GetChannelCenterFrequencySegment0 () << "|"
+     << +VhtOperation.GetChannelCenterFrequencySegment1 () << "|"
+     << VhtOperation.GetBasicVhtMcsAndNssSet ();
+  return os;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/vht/vht-operation.h ns-3.34/src/wifi/model/vht/vht-operation.h
--- ns-3.33/src/wifi/model/vht/vht-operation.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/vht/vht-operation.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,143 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2016 Sébastien Deronne
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef VHT_OPERATION_H
+#define VHT_OPERATION_H
+
+#include "ns3/wifi-information-element.h"
+
+namespace ns3 {
+
+/**
+ * \brief The VHT Operation Information Element
+ * \ingroup wifi
+ *
+ * This class knows how to serialise and deserialise
+ * the VHT Operation Information Element
+ */
+class VhtOperation : public WifiInformationElement
+{
+public:
+  VhtOperation ();
+
+  // Implementations of pure virtual methods of WifiInformationElement
+  WifiInformationElementId ElementId () const override;
+  uint8_t GetInformationFieldSize () const override;
+  void SerializeInformationField (Buffer::Iterator start) const override;
+  uint8_t DeserializeInformationField (Buffer::Iterator start, uint8_t length) override;
+  /* This information element is a bit special in that it is only
+     included if the STA is a VHT STA. To support this we
+     override the Serialize and GetSerializedSize methods of
+     WifiInformationElement. */
+  Buffer::Iterator Serialize (Buffer::Iterator start) const override;
+  uint16_t GetSerializedSize () const override;
+
+  /**
+   * Set the VHT supported information element.
+   *
+   * \param vhtSupported the VHT supported information element
+   */
+  void SetVhtSupported (uint8_t vhtSupported);
+
+  /**
+   * Set the Channel Width field in the VHT Operation information element.
+   *
+   * \param channelWidth the Channel Width field in the VHT Operation information element
+   */
+  void SetChannelWidth (uint8_t channelWidth);
+  /**
+   * Set the Channel Center Frequency Segment 0 field in the VHT Operation information element.
+   *
+   * \param channelCenterFrequencySegment0 the Channel Center Frequency Segment 0 field in the VHT Operation information element
+   */
+  void SetChannelCenterFrequencySegment0 (uint8_t channelCenterFrequencySegment0);
+  /**
+   * Set the Channel Center Frequency Segment 1 field in the VHT Operation information element.
+   *
+   * \param channelCenterFrequencySegment1 the Channel Center Frequency Segment 1 field in the VHT Operation information element
+   */
+  void SetChannelCenterFrequencySegment1 (uint8_t channelCenterFrequencySegment1);
+  /**
+   * Set the Basic VHT-MCS and NSS field in the VHT Operation information element.
+   *
+   * \param basicVhtMcsAndNssSet the Basic VHT-MCS and NSS field in the VHT Operation information element
+   */
+  void SetBasicVhtMcsAndNssSet (uint16_t basicVhtMcsAndNssSet);
+  /**
+   * Set the Basic VHT-MCS and NSS field in the VHT Operation information element
+   * by specifying the tuple (nss, maxMcs).
+   *
+   * \param nss the NSS
+   * \param maxVhtMcs the maximum supported VHT-MCS value corresponding to that NSS
+   */
+  void SetMaxVhtMcsPerNss (uint8_t nss, uint8_t maxVhtMcs);
+
+  /**
+   * Return the Channel Width field in the VHT Operation information element.
+   *
+   * \return the Channel Width field in the VHT Operation information element
+   */
+  uint8_t GetChannelWidth (void) const;
+  /**
+   * Return the Channel Center Frequency Segment 0 field in the VHT Operation information element.
+   *
+   * \return the Channel Center Frequency Segment 0 field in the VHT Operation information element
+   */
+  uint8_t GetChannelCenterFrequencySegment0 (void) const;
+  /**
+   * Return the Channel Center Frequency Segment 1 field in the VHT Operation information element.
+   *
+   * \return the Channel Center Frequency Segment 1 field in the VHT Operation information element
+   */
+  uint8_t GetChannelCenterFrequencySegment1 (void) const;
+  /**
+   * Return the Basic VHT-MCS And Nss field in the VHT Operation information element.
+   *
+   * \return the Basic VHT-MCS And Nss field in the VHT Operation information element
+   */
+  uint16_t GetBasicVhtMcsAndNssSet (void) const;
+
+
+private:
+  //VHT Operation Information
+  uint8_t m_channelWidth; ///< channel width
+  uint8_t m_channelCenterFrequencySegment0; ///< channel center frequency segment 0
+  uint8_t m_channelCenterFrequencySegment1; ///< channel center frequency segment 1
+
+  //Basic VHT-MCS and NSS Set
+  uint16_t m_basicVhtMcsAndNssSet; ///< basic VHT MCS NSS set
+
+  /// This is used to decide whether this element should be added to the frame or not
+  uint8_t m_vhtSupported;
+};
+
+/**
+ * output stream output operator
+ *
+ * \param os the output stream
+ * \param VhtOperation the VHT operation
+ *
+ * \returns output stream
+ */
+std::ostream &operator << (std::ostream &os, const VhtOperation &VhtOperation);
+
+} //namespace ns3
+
+#endif /* VHT_OPERATION_H */
